﻿// DlgJoyJog.cpp : implemetation file
//

#include "stdafx.h"
#include "resource.h"
#include "../inc/IBase.h"
#include "../inc/IState.h"
#include "JoyJog.h"

#include "DlgJoyJog.h"


#define		IDT_JOG			2000		// timer ID
#define		IDT_JOG_UPDATE	2100


long ParseLong(long& lVal, CString strVal);


// DlgJoyJog dialog box

IMPLEMENT_DYNAMIC(DlgJoyJog, CDialog)


/// @brief	Constructor
DlgJoyJog::DlgJoyJog(CWnd* pParent /*=NULL*/)
	: CDialog(DlgJoyJog::IDD, pParent)
	, p_state_(NULL)
{
}


/// @brief	Destructor
DlgJoyJog::~DlgJoyJog()
{
}


void DlgJoyJog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_BT_J1_N, m_btJ1N);
	DDX_Control(pDX, IDC_BT_J1_P, m_btJ1P);
	DDX_Control(pDX, IDC_BT_J2_N, m_btJ2N);
	DDX_Control(pDX, IDC_BT_J2_P, m_btJ2P);
	DDX_Control(pDX, IDC_BT_J3_N, m_btJ3N);
	DDX_Control(pDX, IDC_BT_J3_P, m_btJ3P);

	DDX_Control(pDX, IDC_BT_J4_N, m_btJ4N);
	DDX_Control(pDX, IDC_BT_J4_P, m_btJ4P);
	DDX_Control(pDX, IDC_BT_J5_N, m_btJ5N);
	DDX_Control(pDX, IDC_BT_J5_P, m_btJ5P);
	DDX_Control(pDX, IDC_BT_J6_N, m_btJ6N);
	DDX_Control(pDX, IDC_BT_J6_P, m_btJ6P);
	DDX_Control(pDX, IDC_BT_JOG_INCH, m_btJogInch);
	DDX_Control(pDX, IDC_BT_CRD_SYS, m_btCrdSys);
	DDX_Control(pDX, IDC_BT_MECH_NO, m_btMechNo);
}


BEGIN_MESSAGE_MAP(DlgJoyJog, CDialog)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BT_JOG_INCH, &DlgJoyJog::OnBnClickedBtJogInch)
	ON_BN_CLICKED(IDC_BT_M_SPD_LEV_DEC, &DlgJoyJog::OnBnClickedBtMSpdLevDec)
	ON_BN_CLICKED(IDC_BT_M_SPD_LEV_INC, &DlgJoyJog::OnBnClickedBtMSpdLevInc)
	ON_BN_CLICKED(IDC_BT_CRD_SYS, &DlgJoyJog::OnBnClickedBtCrdSys)
	ON_BN_CLICKED(IDC_BT_SET_UCRD_NO, &DlgJoyJog::OnBnClickedBtSetUcrdNo)
	ON_BN_CLICKED(IDC_BT_SET_TOOL_NO, &DlgJoyJog::OnBnClickedBtSetToolNo)
	ON_BN_CLICKED(IDC_BT_MECH_NO, &DlgJoyJog::OnBnClickedBtMechNo)
END_MESSAGE_MAP()


// DlgJoyJog 메시지 처리기입니다.

// --------------------------------------------------------
/// @brief		initializing dialog
// --------------------------------------------------------
BOOL DlgJoyJog::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  여기에 추가 초기화 작업을 추가합니다.
	SetTimer(IDT_JOG, 100, 0);
	SetTimer(IDT_JOG_UPDATE, 300, 0);

	// display valid user coordinate system numbers
	SetDlgItemText(IDC_ST_VALID_UCRD_NO, GetStringUCrd());

	return TRUE;  // return TRUE unless you set the focus to a control
	// 예외: OCX 속성 페이지는 FALSE를 반환해야 합니다.
}


// --------------------------------------------------------
/// @brief		destroying dialog
// --------------------------------------------------------
void DlgJoyJog::OnDestroy()
{
	CDialog::OnDestroy();

	KillTimer(IDT_JOG);
	KillTimer(IDT_JOG_UPDATE);
}


// --------------------------------------------------------
/// @brief		timer handler
///				check the push-buttons' state
///				and call jog service
// --------------------------------------------------------
void DlgJoyJog::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == IDT_JOG)
	{
		JoyJog	jj;


		if(p_state_==NULL) return;

		// clear all bits
		jj.usBits = 0;

		if(m_btJ1N.IsPushed()) jj.bits.bJ1_N = 1;
		if(m_btJ1P.IsPushed()) jj.bits.bJ1_P = 1;
		if(m_btJ2N.IsPushed()) jj.bits.bJ2_N = 1;
		if(m_btJ2P.IsPushed()) jj.bits.bJ2_P = 1;
		if(m_btJ3N.IsPushed()) jj.bits.bJ3_N = 1;
		if(m_btJ3P.IsPushed()) jj.bits.bJ3_P = 1;

		if(m_btJ4N.IsPushed()) jj.bits.bJ4_N = 1;
		if(m_btJ4P.IsPushed()) jj.bits.bJ4_P = 1;
		if(m_btJ5N.IsPushed()) jj.bits.bJ5_N = 1;
		if(m_btJ5P.IsPushed()) jj.bits.bJ5_P = 1;
		if(m_btJ6N.IsPushed()) jj.bits.bJ6_N = 1;
		if(m_btJ6P.IsPushed()) jj.bits.bJ6_P = 1;

		p_state_->JoystickJog(jj.usBits, 0, 0, 0);
	}

	else if(nIDEvent == IDT_JOG_UPDATE)
	{
		CString		strText;
		int			iToolNo, iUCrdNo, iManSpdLev;
		int			iJogInching, iMechNo, iCrdSys;

		
		if(p_state_==NULL) return;
		
		p_state_->GetUCrdNo(iUCrdNo);
		p_state_->GetManSpdLev(iManSpdLev);
		p_state_->GetToolNo(iToolNo);
		
		SetDlgItemInt(IDC_ED_UCRD_NO, iUCrdNo);
		SetDlgItemInt(IDC_ED_MAN_SPD_LEV, iManSpdLev);
		SetDlgItemInt(IDC_ED_TOOL_NO, iToolNo);

		// jog inching
		p_state_->GetJogInching(iJogInching);
		if(iJogInching)	strText = _T("ON");
		else			strText = _T("OFF");
		m_btJogInch.SetWindowText(strText);

		// mechanism number
		p_state_->GetMechNo(iMechNo);
		strText.Format(_T("M%d"), iMechNo);
		m_btMechNo.SetWindowText(strText);

		// coordinate system
		p_state_->GetCrdSys(iCrdSys);
		if(iCrdSys==0)		strText = _T("AXIS");
		else if(iCrdSys==1)	{
			if(iUCrdNo==0)	strText = _T("CART.");
			else			strText.Format(_T("User[%d]"), iUCrdNo);
		}
		else if(iCrdSys==2)	strText = _T("TOOL");
		else				strText = _T("?");
		m_btCrdSys.SetWindowText(strText);
	}

	CDialog::OnTimer(nIDEvent);
}


// --------------------------------------------------------
/// @brief		set user coordinate number
// --------------------------------------------------------
void DlgJoyJog::OnBnClickedBtSetUcrdNo()
{
	long	lNo, lRet;
	int		iaProgNo[10];

	if(p_state_==NULL) return;

	lNo = GetDlgItemInt(IDC_ED_UCRD_NO_NEW);

	// check the validity of the number
	if(lNo<0 || lNo>10) return;
	if(lNo > 0) {
		lRet = p_state_->GetProgNoUsedToMakeUCrd(iaProgNo);
		if(lRet<0) return;
		if(iaProgNo[lNo-1] <= 0) return;	// undefined number
	}
	
	p_state_->SetUCrdNo(lNo);
}


// --------------------------------------------------------
/// @brief		decrease the manual speed level
// --------------------------------------------------------
void DlgJoyJog::OnBnClickedBtMSpdLevDec()
{
	long	lLev;

	if(p_state_==NULL) return;

	// get current level
	lLev = GetDlgItemInt(IDC_ED_MAN_SPD_LEV);
	if(lLev <= 1) return;

	lLev--;
	p_state_->SetManSpdLev(lLev);
}


// --------------------------------------------------------
/// @brief		increase the manual speed level
// --------------------------------------------------------
void DlgJoyJog::OnBnClickedBtMSpdLevInc()
{
	long	lLev;

	if(p_state_==NULL) return;

	// get current level
	lLev = GetDlgItemInt(IDC_ED_MAN_SPD_LEV);
	if(lLev >= 8) return;

	lLev++;
	p_state_->SetManSpdLev(lLev);
}


// --------------------------------------------------------
/// @brief		switch coordinate system for jog
// --------------------------------------------------------
void DlgJoyJog::OnBnClickedBtCrdSys()
{
	if(p_state_==NULL) return;
	p_state_->SetCrdSys(-1);
}


// --------------------------------------------------------
/// @brief		toggle the state of jog-inching
// --------------------------------------------------------
void DlgJoyJog::OnBnClickedBtJogInch()
{
	if(p_state_==NULL) return;
	p_state_->SetJogInching(-1);
}


// --------------------------------------------------------
/// @brief		switch mechanism number to next valid number
// --------------------------------------------------------
void DlgJoyJog::OnBnClickedBtMechNo()
{
	HRESULT	hr;
	int		i, iMechNoCur, iMechNoNew;
	

	if(p_state_==NULL) return;

	p_state_->GetMechNo(iMechNoCur);
	iMechNoNew = iMechNoCur;

	for(i=0; i<8; i++)
	{
		iMechNoNew++;
		if(iMechNoNew >= 8) iMechNoNew = 0;

		hr = p_state_->SetMechNo(iMechNoNew);
		if(SUCCEEDED(hr)) break;	// valid number
	}

	if(hr==BASE_E_PARAM_INVALID) return;		// no other valid mechanism number
}


// --------------------------------------------------------
/// @brief		set tool number
// --------------------------------------------------------
void DlgJoyJog::OnBnClickedBtSetToolNo()
{
	long	lNo;

	if(p_state_==NULL) return;

	lNo = GetDlgItemInt(IDC_ED_TOOL_NO_NEW);
	p_state_->SetToolNo(lNo);
}


// --------------------------------------------------------
/// @brief		returns string of valid coordinate system numbers
///				ex: "{1,5}"
// --------------------------------------------------------
CString DlgJoyJog::GetStringUCrd(void)
{
	HRESULT	hr;
	int		iaProgNo[10], iUCrdNo, iNProgNo = 0;
	CString	strUCrdNo, strTmp;


	if(p_state_==NULL) return _T("");

	hr = p_state_->GetProgNoUsedToMakeUCrd(iaProgNo);
	if(FAILED(hr)) return _T("");

	strUCrdNo = _T("{");
	for(iUCrdNo=0; iUCrdNo<10; iUCrdNo++) {
		if(iaProgNo[iUCrdNo] == 0) continue;
		strTmp.Format(_T("%d"), iUCrdNo+1);	
		if(iNProgNo>0) strUCrdNo += _T(",");
		strUCrdNo += strTmp;
		
		iNProgNo++;
	}
	strUCrdNo += _T("}");
	
	if(iNProgNo == 0) strUCrdNo = _T("{none}");

	return strUCrdNo;
}

