﻿// DlgState.cpp : 구현 파일입니다.
//

#include "stdafx.h"
#include <TCHAR.H>
#include "HRRpcCli.h"
#include "HRRpcCliDlg.h"
#include "DlgJoyJog.h"
#include "COM/Loose_COM.h"
#include "../inc/IState.h"
#include "../inc/IPose.h"


#include "DlgState.h"



#define IDT_UPDATE		1500


namespace prx = hr_rpc_proxy;	// shorten name

// function prototypes
CString errcode2msg(int iErrCode);


// DlgState dialog box

IMPLEMENT_DYNAMIC(DlgState, CDialog)

// --------------------------------------------------------
/// @brief		constructor
// --------------------------------------------------------
DlgState::DlgState(CWnd* pParent /*=NULL*/)
	: CDialog(DlgState::IDD, pParent)
	, h_module_(NULL)
	, p_base_(NULL)
	, p_state_(NULL)
	, p_pose_(NULL)
{
	dlgp_main_ = static_cast<HRRpcCliDlg*>(pParent);
}


// --------------------------------------------------------
/// @brief		destructor
// --------------------------------------------------------
DlgState::~DlgState()
{
}


void DlgState::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_CB_IO_CLASS, m_cbIoClass);
	DDX_Control(pDX, IDC_ED_IO_OBJ_IDX, m_edIoObjIdx);
	DDX_Control(pDX, IDC_CB_IO_TYPE, m_cbIoType);
	DDX_Control(pDX, IDC_IO_SET_VAL, m_btIoSetVal);
	DDX_Control(pDX, IDC_ED_IO_VAL_NEW, m_edIoValNew);
	DDX_Control(pDX, IDC_R_VAR_GLOBAL, m_btVarGlobal);
	DDX_Control(pDX, IDC_R_VAR_LOCAL, m_btVarLocal);
	DDX_Control(pDX, IDC_CB_VAR_TYPE, m_cbVarType);
	DDX_Control(pDX, IDC_CB_TOOL_NO, m_cbToolNo);
	DDX_Control(pDX, IDC_CB_UCRD, m_cbUCrd);
	DDX_Control(pDX, IDC_R_BASE, m_btBase);
	DDX_Control(pDX, IDC_R_ANGLE, m_btAngle);
}


BEGIN_MESSAGE_MAP(DlgState, CDialog)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_PB_RESET, &DlgState::OnBnClickedPbReset)
	ON_BN_CLICKED(IDC_PB_START, &DlgState::OnBnClickedPbStart)
	ON_BN_CLICKED(IDC_PB_STOP, &DlgState::OnBnClickedPbStop)
	ON_BN_CLICKED(IDC_SEL_JOB, &DlgState::OnBnClickedSelJob)
	ON_BN_CLICKED(IDC_SEL_STEP_FUNC, &DlgState::OnBnClickedSelStepFunc)

	ON_CBN_SELCHANGE(IDC_CB_TOOL_NO, &DlgState::OnCbnSelchangeCbToolNo)
	ON_BN_CLICKED(IDC_SEL_TOOL_NO, &DlgState::OnBnClickedSelToolNo)
	ON_BN_CLICKED(IDC_SET_TOOL, &DlgState::OnBnClickedSetTool)

	ON_CBN_SELCHANGE(IDC_CB_IO_CLASS, &DlgState::OnCbnSelchangeCbIoClass)
	ON_BN_CLICKED(IDC_END_EVT_HANDLE, &DlgState::OnBnClickedEndEvtHandle)
	ON_BN_CLICKED(IDC_IO_SET_VAL, &DlgState::OnBnClickedIoSetVal)
	ON_BN_CLICKED(IDC_VAR_SET_VAL, &DlgState::OnBnClickedVarSetVal)
	ON_BN_CLICKED(IDC_POSE_GET, &DlgState::OnBnClickedPoseGet)
	ON_BN_CLICKED(IDC_POSE_SET, &DlgState::OnBnClickedPoseSet)

	ON_BN_CLICKED(IDC_BT_INTP, &DlgState::OnBnClickedBtIntp)
	ON_BN_CLICKED(IDC_STEP_PRM_GET, &DlgState::OnBnClickedStepPrmGet)
	ON_BN_CLICKED(IDC_STEP_PRM_SET, &DlgState::OnBnClickedStepPrmSet)
	ON_BN_CLICKED(IDC_R_BASE, &DlgState::OnBnClickedRBase)
	ON_BN_CLICKED(IDC_R_ANGLE, &DlgState::OnBnClickedRAngle)

	ON_BN_CLICKED(IDC_JOY_JOG, &DlgState::OnBnClickedJoyJog)
END_MESSAGE_MAP()


// --------------------------------------------------------
/// @return
///			- 0		success
///			- -1	error
/// @brief		Initialize HRRpcProxy - State
// --------------------------------------------------------
int DlgState::InitProxyState()
{
	HRESULT		hr;

	// ------------------------------------------
	// Create COM component instances & get interface - IState
	hr = CreateInstanceFromInst(h_module_, hr_rpc_proxy::CLSID_State, hr_rpc_proxy::IID_IState, (void**)&p_state_);
	if(FAILED(hr)) {
		MessageBox(_T("Error in getting IState."), 0, MB_OK | MB_ICONSTOP);
		return -1;
	}

	// bind the proxy base interface
	p_state_->SetProxyBase(p_base_);

	// ------------------------------------------
	// Create COM component instances & get interface - IPose
	hr = CreateInstanceFromInst(h_module_, hr_rpc_proxy::CLSID_Pose, hr_rpc_proxy::IID_IPose, (void**)&p_pose_);
	if(FAILED(hr)) {
		MessageBox(_T("Error in getting IPose."), 0, MB_OK | MB_ICONSTOP);
		return -1;
	}


	return 0;
}


// --------------------------------------------------------
/// @return
///			- 0		success
/// @brief		End HRRpcProxy - State
// --------------------------------------------------------
int DlgState::EndProxyState()
{
	if(p_state_)
	{
		p_state_->Release();
		p_state_ = NULL;
	}

	if(p_pose_)
	{
		p_pose_->Release();
		p_pose_ = NULL;
	}

	return 0;
}


// DlgState message handlers

// --------------------------------------------------------
/// @return		TRUE
/// @brief		initialize dialog
// --------------------------------------------------------
BOOL DlgState::OnInitDialog()
{
	CDialog::OnInitDialog();

	// initializing ----------------------------
	int			iHEv, iT;
	CString		strToolNo;

	// create COM component instance & get interface
	InitProxyState();

	// subscribe as event-receiver
	p_state_->InitEvent(iHEv);

	// prog.counter
	SetDlgItemInt(IDC_ED_SEL_JOB, 1);
	SetDlgItemInt(IDC_ED_SEL_STEP, 0);
	SetDlgItemInt(IDC_ED_SEL_FUNC, 0);

	// robot current pose
	m_cbUCrd.SetCurSel(0);

	// pose variable
	m_btAngle.SetCheck(BST_CHECKED);

	// I/O
	SetDlgItemInt(IDC_ED_IO_OBJ_IDX, 1);
	SetDlgItemInt(IDC_ED_IO_IDX, 1);
	m_cbIoClass.SetCurSel(0);
	m_cbIoType.SetCurSel(0);

	// variable
	m_btVarGlobal.SetCheck(BST_CHECKED);
	m_cbVarType.SetCurSel(0);
	SetDlgItemInt(IDC_ED_VAR_IDX, 1);

	// Tool numbers combo box
	for(iT=0; iT<16; iT++)
	{
		strToolNo.Format(_T("T%d"), iT);
		m_cbToolNo.AddString(strToolNo);
	}
	m_cbToolNo.SetCurSel(0);

	// timer (periodically receive the various information of remote robot controller.)
	SetTimer(IDT_UPDATE, 300, NULL);	// 300msec

	
	return TRUE;  // return TRUE unless you set the focus to a control
	// exception: OCX property page must return FALSE
}


// --------------------------------------------------------
/// @brief		handle destruction of dialog
// --------------------------------------------------------
void DlgState::OnDestroy()
{
	CDialog::OnDestroy();

	KillTimer(IDT_UPDATE);

	// unsubscribe as event-receiver
	p_state_->EndEvent();

	EndProxyState();
}


// --------------------------------------------------------
/// @param		nIDEvent
/// @brief		Periodically receive the various information of remote robot controller.
// --------------------------------------------------------
void DlgState::OnTimer(UINT_PTR nIDEvent)
{
	if(nIDEvent == IDT_UPDATE)
	{
		HRESULT		hr;
		bool		bConn, bOn;
		
		int			iTotalOperDay, iTotalOperTime;
		ULONG		ulTotalMotorOnDay, ulTotalMotorOnTime;

		int			iJobState, iSubJobState;
		CString		strState;
		CString		strProgCnt;
		CString		strRunTime, strMotOnTime;
		int			iProgNo, iStepNo, iFuncNo, iInPosi;
		char		cInPosi;


		if(p_base_ != NULL)
		{
			p_base_->IsOpened(&bConn);
			if(bConn && p_state_!=NULL)
			{
				// ------------------------------
				// Request and receive all state of remote robot controller.
				hr = p_state_->UpdateState();
				if(FAILED(hr)) {
					EndProxyState();	// when communication error, prohibit hang (not to disable manipulating dialog box.)
					return;
				}

				p_state_->GetJobState(iJobState);
				p_state_->GetSubJobState(iSubJobState);

static int iJobStateOld = 0;
if(iJobStateOld != iJobState) {
	TRACE(_T("iJobStateOld=%d, iJobState=%d \r\n"), iJobStateOld, iJobState);
	iJobStateOld = iJobState;
}

				// job state
				switch(iJobState)
				{
				case 0:
					strState = _T("playback");
					break;

				case 1:
					strState = _T("step go");
					break;

				case 2:
					strState = _T("step back");
					break;

				default:
					strState = _T("stop");
					break;
				};

				// job sub-state
				switch(iSubJobState)
				{
				case 4:
					strState = _T("waiting time");
					break;

				case 5:
					strState = _T("waiting in.signal");
					break;

				case 23:
					strState = _T("WAITing");
					break;
				};

				// ------------------------------
				// program counter
				p_state_->GetProgCnt(iProgNo, iStepNo, iFuncNo);
				p_state_->GetInPosition(iInPosi);
				if(iInPosi)	cInPosi = '=';
				else		cInPosi = ':';
				
				strProgCnt.Format(_T("%cP%04d/S%d/F%d"), cInPosi, iProgNo, iStepNo, iFuncNo);


				// Motor
				if(p_state_->IsMotorOn(bOn)) {
					SetDlgItemText(IDC_ED_MOTOR, _T("ON"));
				}
				else {
					SetDlgItemText(IDC_ED_MOTOR, _T("OFF"));
				}

				// ------------------------------
				// Operating time
				p_state_->UpdateOpTime(0);

				p_state_->GetTotalOperTime(iTotalOperDay, iTotalOperTime);
				p_state_->GetTotalMotorOnTime(ulTotalMotorOnDay, ulTotalMotorOnTime);;
				
				strRunTime = OperTimeDispProc(iTotalOperDay, iTotalOperTime);
				strMotOnTime = MotOnTimeDispProc(ulTotalMotorOnDay, ulTotalMotorOnTime);


				// update events
				UpdateEvent();

				// robot pose
				UpdateCurPose();

				// update I/O
				UpdateIo();

				// update variables
				UpdateVar();
			}
		}

		// ------------------------------
		// Set Edit controls
		SetDlgItemText(IDC_ED_ST, strState);					// state
		SetDlgItemText(IDC_ED_PROG_CNT, strProgCnt);			// program counter
		SetDlgItemText(IDC_ED_RUN_TIME, strRunTime);			// running  time
		SetDlgItemText(IDC_ED_MOTOR_ON_TIME, strMotOnTime);		// motor on time
	}
}



// --------------------------------------------------------
/// @return		iDay	days
///				iDt		time (unit: 10msec)
/// @brief		Return the string of operating time
// --------------------------------------------------------
CString DlgState::OperTimeDispProc(int iDay, int iDt)
{
	long		lHour, lMin, lSec, l10MSec;
	CString		strOperTime;


	l10MSec = iDt % 100;
	iDt /= 100;
	lSec = iDt % 60;
	iDt /= 60;
	lMin = iDt % 60;
	lHour = iDt/60;

	if(iDay==0) {
		strOperTime.Format(_T("%02d:%02d:%02d.%02d "), lHour, lMin, lSec, l10MSec);
	}
	else {
		strOperTime.Format(_T("%d/%02d:%02d:%02d.%02d "), iDay, lHour, lMin, lSec, l10MSec);
	}

	return strOperTime;
}


// --------------------------------------------------------
/// @return		iDay	days
///				iDt		time (unit: sec)
/// @brief		Return the string of motor-on time
// --------------------------------------------------------
CString DlgState::MotOnTimeDispProc(int iDay, int iDt)
{
	long		lHour, lMin, lSec;
	CString		strOperTime;


	lSec = iDt % 60;
	iDt /= 60;
	lMin = iDt % 60;
	lHour = iDt/60;

	strOperTime.Format(_T("%d/%02d:%02d:%02d "), iDay, lHour, lMin, lSec);

	return strOperTime;
}


// --------------------------------------------------------
/// @brief		Get every errors and warnings since last fetch and output them to log edit
// --------------------------------------------------------
void DlgState::UpdateEvent()
{
	HRESULT		hr;
	int			i, iNEvt=0, iEvtType, iEvtNum, iEvtAux;
	char		cEvtType;
	CString		strWhole, strMsg, strTime;


	if(p_state_==NULL) return;

	// get every events since last fetch
	hr = p_state_->UpdateEvent();
	if(FAILED(hr)) return;
	
	hr = p_state_->GetNEvent(iNEvt);
	if(FAILED(hr)) return;

	for(i=0; i<iNEvt; i++)
	{
		p_state_->GetEvent(i, iEvtType, iEvtNum, iEvtAux);

		// type
		if(iEvtType==0) {			// error
			cEvtType = 'E';
		}
		else if(iEvtType==1) {		// warning
			cEvtType = 'W';
		}
		else {		// don't display other type of events
			continue;
		}

		// make message string
		strMsg.Format(_T("%c%05d (aux.info=%d)"), cEvtType, iEvtNum, iEvtAux);

		// time stamp
		CTime	t = CTime::GetCurrentTime();
		strTime.Format(_T("[%02d, %02d:%02d:%02d] ")
			, t.GetDay(), t.GetHour(), t.GetMinute(), t.GetSecond());
		
		// output to log edit
		strWhole.Format(_T("%s %s\r\n"), strTime, strMsg);
		dlgp_main_->LogToMonitor(strWhole);
	}
}



// --------------------------------------------------------
/// @return		0	Success
///				<0	Error
/// @brief		Display robot pose current (not command) values
///				with BASE and ANGLE coordinate system on Edit controls
// --------------------------------------------------------
void DlgState::UpdateCurPose()
{
	HRESULT		hr;
	int			iErrCode;
	int			iUCrdNumReq;

	double		daMmDeg[kNJointMax];
	CString		strMsg, strTgtJoint;

	
	// user coordinate number	(0: current #, 1~10: specified)
	iUCrdNumReq = m_cbUCrd.GetCurSel();

	// ANGLE
	p_state_->GetCurPose(CRD_ANGLE, 0, p_pose_);
	SetDlgItemText(IDC_ED_POSE_ANG, MakePoseStr(p_pose_));

	// BASE
	p_state_->GetCurPose(CRD_BASE, 0, p_pose_);
	SetDlgItemText(IDC_ED_POSE_BASE, MakePoseStr(p_pose_));

	// USER
	hr = p_state_->GetCurPose(CRD_USER, iUCrdNumReq, p_pose_);
	if(hr==BASE_E_SERVICE)
	{
		p_base_->GetSvcErrCode(iErrCode);
		strMsg = errcode2msg(iErrCode);
	}
	else if(SUCCEEDED(hr))
	{
		SetDlgItemText(IDC_ED_POSE_UCRD, MakePoseStr(p_pose_));
	}

	// Target Joint
	p_state_->GetTgtJointVal(0, daMmDeg);
	strTgtJoint.Format(_T("(%.1f, %.1f, %.1f, %.1f, %.1f, %.1f)")
		, daMmDeg[0], daMmDeg[1], daMmDeg[2], daMmDeg[3], daMmDeg[4], daMmDeg[5]);
	SetDlgItemText(IDC_ED_TGT_JOINT, strTgtJoint);
}


// --------------------------------------------------------
/// @param[in]	pPose	pointer to instance of IPose to make string
/// @return		pose string (e.g. "(10.5, 90, -20.6, 11.7, 30, 0)")
// --------------------------------------------------------
CString DlgState::MakePoseStr(const prx::IPose* pPose)
{
	CString	strPose;
	int		iCrd, iUCrdNum, iUnit;
	int		iaCfg[kNCfgElem];
	double	daJ[kNJointMax];

	pPose->GetJ(daJ);
	pPose->GetCfg(iaCfg, iCrd, iUCrdNum, iUnit);
		
	strPose.Format(_T("(%.1f, %.1f, %.1f, %.1f, %.1f, %.1f)")
					, daJ[0], daJ[1], daJ[2], daJ[3], daJ[4], daJ[5]);

	return strPose;
}


// --------------------------------------------------------
/// @brief		Get/display current value of specified I/O
///				on IDC_ED_IO_VAL_CUR Edit control.
// --------------------------------------------------------
void DlgState::UpdateIo()
{
	HRESULT	hr;
	int		iObjIdx, iClass, iType, iIdx, iVal;
	bool	bOut;
	double	dVal;
	CString	strVal;


	// class
	iClass = m_cbIoClass.GetCurSel();

	switch(iClass) 
	{
	case prx::CLS_Y:				// FN.Y
	case prx::CLS_FB_Y:
	case prx::CLS_X:
	case prx::CLS_FB_X:
		// obj. index
		iObjIdx = GetDlgItemInt(IDC_ED_IO_OBJ_IDX);
		if(iObjIdx<=0) return;
		break;

	default:
		iObjIdx = 0;	// not used
		break;
	};

	// data type
	iType = m_cbIoType.GetCurSel();

	// index
	iIdx = GetDlgItemInt(IDC_ED_IO_IDX);
	if(iIdx<=0) return;

	// analog real data
	if(iClass==prx::CLS_AO || iClass==prx::CLS_AI)
	{
		bOut = (iClass==prx::CLS_AO);

		// getting value
		hr = p_state_->GetAnalogIo(bOut, iIdx-1, &dVal);
		if(FAILED(hr)) return;

		strVal.Format(_T("%.2f"), dVal);
	}

	// digital integer data
	else
	{
		// get value
		hr = p_state_->GetRelayValue(iObjIdx, iClass, iType, iIdx, &iVal);
		if(FAILED(hr)) return;

		strVal.Format(_T("%d"), iVal);
	}

	// display on edit
	SetDlgItemText(IDC_ED_IO_VAL_CUR, strVal);
}


// --------------------------------------------------------
/// @return		0	Success
///				<0	Error
/// @brief		Get/display current value of specified variable.
///				on IDC_ED_VAR_VAL_CUR Edit control.
// --------------------------------------------------------
void DlgState::UpdateVar()
{
	HRESULT	hr;
	int		iType, iIdx, iErrCode;
	char	cScope;
	short	sVal;
	float	fVal;
	CString	strVal;
	_bstr_t	bstrVal;


	// scope
	if(m_btVarGlobal.GetCheck()==BST_CHECKED)	cScope='G';
	else										cScope='L';

	// data type
	iType = m_cbVarType.GetCurSel();

	// index
	iIdx = GetDlgItemInt(IDC_ED_VAR_IDX);
	if(iIdx<=0) return;

	// getting value
	switch(iType)
	{
	case 0:		// V%(int)
		hr = p_state_->GetVarInt(cScope, iIdx, &sVal);
		strVal.Format(_T("%d"), sVal);
		break;

	case 1:		// V!(float)
		hr = p_state_->GetVarFlt(cScope, iIdx, &fVal);
		strVal.Format(_T("%f"), fVal);
		break;

	case 2:		// V$(string)
		hr = p_state_->GetVarStr(cScope, iIdx, bstrVal.GetBSTR());
		strVal = bstrVal.GetBSTR();
		break;

	default:
		return;
	};

	// error
	if(FAILED(hr)) {
		if(hr==BASE_E_SERVICE) {
			p_base_->GetSvcErrCode(iErrCode);
			strVal.Format(_T("service error(-%x)"), -iErrCode);
		}
		else {
			strVal.Format(_T("error(%x)"), hr);
		}
	}

	// display on edit
	SetDlgItemText(IDC_ED_VAR_VAL_CUR, strVal);
}


// --------------------------------------------------------
/// @brief		Start the remote robot
// --------------------------------------------------------
void DlgState::OnBnClickedPbStart()
{
	if(p_state_==NULL) return;

	p_state_->PBackStartStop(1, 2);
}


// --------------------------------------------------------
/// @brief		Stop the remote robot
// --------------------------------------------------------
void DlgState::OnBnClickedPbStop()
{
	if(p_state_==NULL) return;

	p_state_->PBackStartStop(0, 0);
}


// --------------------------------------------------------
/// @brief		Reset the remote robot
// --------------------------------------------------------
void DlgState::OnBnClickedPbReset()
{
	if(p_state_==NULL) return;

	p_state_->Reset();
}


// --------------------------------------------------------
/// @brief		Select current JOB as IDC_ED_SEL_JOB
// --------------------------------------------------------
void DlgState::OnBnClickedSelJob()
{
	if(p_state_==NULL) return;

	int iProgNo = GetDlgItemInt(IDC_ED_SEL_JOB, 0, 0);
	p_state_->SelProg(iProgNo, 0, 1);	// (changed only when the TP mode switch is on ext.mode)
}


// --------------------------------------------------------
/// @brief		Select current STEP/FUNC as IDC_ED_SEL_STEP/IDC_ED_SEL_FUNC
// --------------------------------------------------------
void DlgState::OnBnClickedSelStepFunc()
{
	if(p_state_==NULL) return;

	int iStepNo = GetDlgItemInt(IDC_ED_SEL_STEP, 0, 0);
	int iFuncNo = GetDlgItemInt(IDC_ED_SEL_FUNC, 0, 0);
	int	iTaskNo=0;

	p_state_->SelStepFunc(iStepNo, iFuncNo, iTaskNo);
}


// --------------------------------------------------------
/// @brief		Receive and display the tool data of IDC_CB_TOOL_NO
// --------------------------------------------------------
void DlgState::OnCbnSelchangeCbToolNo()
{
	HRESULT	hr;
	long	lE;
	long	lToolNo = m_cbToolNo.GetCurSel();
	double	daElem[6];
	CString	strToolDt;

	int		iaId[6] = { IDC_ED_TOOL_X, IDC_ED_TOOL_Y, IDC_ED_TOOL_Z
					, IDC_ED_TOOL_RX, IDC_ED_TOOL_RY, IDC_ED_TOOL_RZ };

	
	if(p_state_==NULL) return;

	hr = p_state_->GetToolData(lToolNo, daElem);
	if(FAILED(hr)) return;

	for(lE=0; lE<6; lE++)
	{
		strToolDt.Format(_T("%.1f"), daElem[lE]);
		SetDlgItemText(iaId[lE], strToolDt);
	}
}


// --------------------------------------------------------
/// @brief		select current tool number
// --------------------------------------------------------
void DlgState::OnBnClickedSelToolNo()
{
	if(p_state_==NULL) return;

	int iToolNo = m_cbToolNo.GetCurSel();
	p_state_->SetToolNo(iToolNo);
}


// --------------------------------------------------------
/// @brief		Set tool data of IDC_CB_TOOL_NO
// --------------------------------------------------------
void DlgState::OnBnClickedSetTool()
{
	long	lE;
	long	lToolNo = m_cbToolNo.GetCurSel();
	double	daElem[6];
	TCHAR	tcaVal[10];

	int		iaId[6] = { IDC_ED_TOOL_X, IDC_ED_TOOL_Y, IDC_ED_TOOL_Z
					, IDC_ED_TOOL_RX, IDC_ED_TOOL_RY, IDC_ED_TOOL_RZ };


	if(p_state_==NULL) return;

	for(lE=0; lE<6; lE++)
	{
		GetDlgItemText(iaId[lE], tcaVal, 10);
		daElem[lE] = _tstof(tcaVal);
	}

	p_state_->SetToolData(lToolNo, daElem);
}


// --------------------------------------------------------
/// @param		void
/// @return		void
/// @brief		On change of I/O class, adjust the controls.
// --------------------------------------------------------
void DlgState::OnCbnSelchangeCbIoClass()
{
	long lIoClass;


	lIoClass = m_cbIoClass.GetCurSel();

	switch(lIoClass) 
	{
	case prx::CLS_X:	case prx::CLS_Y:				// FN.X, FN.Y
		SetDlgItemText(IDC_ST_OBJ_NAME, _T("FN"));
		m_edIoObjIdx.SetWindowText(_T("1"));
		m_edIoObjIdx.EnableWindow(TRUE);
		break;

	case prx::CLS_FB_X:	case prx::CLS_FB_Y:
		SetDlgItemText(IDC_ST_OBJ_NAME, _T("FB"));
		m_edIoObjIdx.SetWindowText(_T("1"));
		m_edIoObjIdx.EnableWindow(TRUE);
		break;

	default:
		SetDlgItemText(IDC_ST_OBJ_NAME, _T(""));
		m_edIoObjIdx.SetWindowText(_T("-"));
		m_edIoObjIdx.EnableWindow(FALSE);
		break;
	};


	// Physical input can not be set(output) new value.
	switch(lIoClass) 
	{
	case prx::CLS_X:
	case prx::CLS_FB_X:
	case prx::CLS_AI:			// FN.Y
		m_btIoSetVal.EnableWindow(FALSE);
		m_edIoValNew.EnableWindow(FALSE);
		break;

	default:
		m_btIoSetVal.EnableWindow(TRUE);
		m_edIoValNew.EnableWindow(TRUE);
		break;
	};

}


// --------------------------------------------------------
/// @brief		forcefully set I/O value
// --------------------------------------------------------
void DlgState::OnBnClickedIoSetVal()
{
	HRESULT	hr;
	int		iObjIdx, iClass, iType, iIdx, iVal;
	TCHAR	tcaVal[10];
	double	dVal;


	// class
	iClass = m_cbIoClass.GetCurSel();

	switch(iClass) 
	{
	case prx::CLS_Y:				// FN.Y
	case prx::CLS_FB_Y:
		// obj. index
		iObjIdx = GetDlgItemInt(IDC_ED_IO_OBJ_IDX);
		if(iObjIdx<=0) return;
		break;

	default:
		iObjIdx = 0;	// not used
		break;
	};

	// index
	iIdx = GetDlgItemInt(IDC_ED_IO_IDX);
	if(iIdx<=0) return;

	// analog real data
	if(iClass==prx::CLS_AO)
	{
		// new value
		GetDlgItemText(IDC_ED_IO_VAL_NEW, tcaVal, 10);
		dVal = _tstof(tcaVal);

		// check the range
		if(dVal < -12.0 || dVal > 12.0) return;		// -12V ~ 12V

		// setting value
		hr = p_state_->SetAnalogOutput(iIdx-1, dVal);
	}

	// digital integer data
	else
	{
		// data type
		iType = m_cbIoType.GetCurSel();

		// new value
		iVal = GetDlgItemInt(IDC_ED_IO_VAL_NEW);

		// setting value
		hr = p_state_->SetRelayValue(iObjIdx, iClass, iType, iIdx, iVal);
	}
}


// --------------------------------------------------------
/// @brief		Handler of set value button (set new variable value)
// --------------------------------------------------------
void DlgState::OnBnClickedVarSetVal()
{
	HRESULT	hr;
	int		iType, iIdx, iErrCode;
	char	cScope;
	TCHAR	tcaVal[10];
	short	sVal;
	float	fVal;
	CString	strVal;


	// scope
	if(m_btVarGlobal.GetCheck()==BST_CHECKED)	cScope='G';
	else										cScope='L';

	// data type
	iType = m_cbVarType.GetCurSel();

	// index
	iIdx = GetDlgItemInt(IDC_ED_VAR_IDX);
	if(iIdx<=0) return;

	// new value
	GetDlgItemText(IDC_ED_VAR_VAL_NEW, tcaVal, 10);

	// getting value
	switch(iType)
	{
	case 0:		// V%(int)
		sVal = (short)_ttoi(tcaVal);
		hr = p_state_->SetVarInt(cScope, iIdx, sVal);
		break;

	case 1:		// V!(float)
		fVal = (float)_tstof(tcaVal);
		hr = p_state_->SetVarFlt(cScope, iIdx, fVal);
		break;

	case 2:		// V$(string)
		hr = p_state_->SetVarStr(cScope, iIdx, bstr_t(tcaVal));
		break;

	default:
		return;
	};

	// error
	if(FAILED(hr)) {
		if(hr==BASE_E_SERVICE) {
			p_base_->GetSvcErrCode(iErrCode);
			strVal.Format(_T("service error(-%x)"), -iErrCode);
		}
		else {
			strVal.Format(_T("error(%x)"), hr);
		}
		MessageBox(strVal, NULL, MB_OK | MB_ICONERROR);
	}
}


// --------------------------------------------------------
/// @brief		On click 'base', change the axis name and unit.
// --------------------------------------------------------
void DlgState::OnBnClickedRBase()
{
	SetDlgItemText(IDC_ST_POSE_L1, _T(" XYZ"));
	SetDlgItemText(IDC_ST_POSE_L2, _T("RXYZ"));
	SetDlgItemText(IDC_ST_POSE_U1, _T("mm"));
}


// --------------------------------------------------------
/// @brief		On click 'angle', change the axis name and unit.
// --------------------------------------------------------
void DlgState::OnBnClickedRAngle()
{
	SetDlgItemText(IDC_ST_POSE_L1, _T("J123"));
	SetDlgItemText(IDC_ST_POSE_L2, _T("J456"));
	SetDlgItemText(IDC_ST_POSE_U1, _T("deg"));
}


#define SVC_IO_VAR_BASE				0x5000000
#define SVC_STATUS_GET_VAR_POSE		(SVC_IO_VAR_BASE + 0x83000)	// 포즈변수값 얻기

// --------------------------------------------------------
/// @brief		Get POSE value of P50 and display it to IDC_ED_MV_Jn \n
///				(Before test this, make P50 variable in Hi5/Hi5a controller.)
// --------------------------------------------------------
void DlgState::OnBnClickedPoseGet()
{
	HRESULT	hr;
	int	 iaId[6] = { IDC_ED_MV_J1, IDC_ED_MV_J2, IDC_ED_MV_J3
				   , IDC_ED_MV_J4, IDC_ED_MV_J5, IDC_ED_MV_J6 };
	int		i;
	int		iCrd, iUCrdNum, iUnit;
	double	daJ[kNJointMax];
	int		iaCfg[kNCfgElem];
	CString strJ;

#if 1
	// 원하는 좌표계로 포즈변수값 얻기
	p_base_->InitParam();
	p_base_->PutData(1);	// option (1;전역, 2; 지역)
	p_base_->PutData(50);	// POSE index (1-based)

	p_base_->PutData(CRD_ANGLE);		// 얻기 원하는 좌표계 종류(-1: 본래 좌표계)
	p_base_->PutData(0);		// 사용자좌표계 번호 (CRD_USER 일 때만 유효)

	hr = p_base_->DoProcSync(SVC_STATUS_GET_VAR_POSE);		// 서비스 호출
	if(FAILED(hr)) return;

	p_base_->GetData_Pose(p_pose_);

	p_pose_->GetJ(daJ);
	p_pose_->GetCfg(iaCfg, iCrd, iUCrdNum, iUnit);

#else

	hr = p_state_->GetVarPose('G', 50, p_pose_);
	if(FAILED(hr)) return;


	p_pose_->GetJ(daJ);
	p_pose_->GetCfg(iaCfg, iCrd, iUCrdNum, iUnit);

	// display coordinate system
	if(iCrd == CRD_BASE) {
		m_btBase.SetCheck(BST_CHECKED);
		m_btAngle.SetCheck(BST_UNCHECKED);
	}
	else {
		m_btAngle.SetCheck(BST_CHECKED);
		m_btBase.SetCheck(BST_UNCHECKED);
	}
#endif

	// display J elements
	for(i=0; i<6; i++)
	{
		strJ.Format(_T("%.1f"), daJ[i]);
		SetDlgItemText(iaId[i], strJ);
	}
}


// --------------------------------------------------------
/// @brief		Set POSE value of P50 with IDC_ED_MV_Jn
// --------------------------------------------------------
void DlgState::OnBnClickedPoseSet()
{
	TCHAR	tcaVal[10];
	int	 iaId[6] = { IDC_ED_MV_J1, IDC_ED_MV_J2, IDC_ED_MV_J3
				   , IDC_ED_MV_J4, IDC_ED_MV_J5, IDC_ED_MV_J6 };
	int		i, iCrd;
	double	daJ[kNJointMax]={0,};
	int		iaCfg[kNCfgElem]={0,};


	// coordinate system
	if(m_btBase.GetCheck()==BST_CHECKED) {
		iCrd = CRD_BASE;
	}
	else {
		iCrd = CRD_ANGLE;
	}

	// element values
	for(i=0; i<6; i++)
	{
		GetDlgItemText(iaId[i], tcaVal, 10);
		daJ[i] = _tstof(tcaVal);
	}

	// set IPose instance
	p_pose_->SetJ(daJ);
	p_pose_->SetCfg(iaCfg, CRD_USER, 5, 0);

	// Call service
	p_state_->SetVarPose('G', 50, p_pose_);
}


// --------------------------------------------------------
/// @brief		Toggle the interpolation	"P" <-> "L".
///				Speed unit is automatically changed.
///				(P:%, L:mm/s)
// --------------------------------------------------------
void DlgState::OnBnClickedBtIntp()
{
	CString		strIntp, strUnit;


	// interpolation
	GetDlgItemText(IDC_BT_INTP, strIntp);

	if(strIntp==_T("P")) {
		strIntp = _T("L");		// Linear
	}
	else {
		strIntp = _T("P");		// PtoP
	}
	SetDlgItemText(IDC_BT_INTP, strIntp);

	// speed unit
	if(strIntp==_T("P")) {
		strUnit = _T("%");
	}
	else {
		strUnit = _T("mm/s");
	}
	SetDlgItemText(IDC_ST_SPD_UNIT, strUnit);
}


// --------------------------------------------------------
/// @brief		Get step parameters.
///				V5$: interpolation ('P', 'L', 'C', ..)
///				V8!: speed
// --------------------------------------------------------
void DlgState::OnBnClickedStepPrmGet()
{
	float	fVal;
	_bstr_t	bstrVal;
	CString	strVal, strUnit;


	// interpolation
	p_state_->GetVarStr('G', 5, bstrVal.GetBSTR());		// V5$
	strVal = bstrVal.GetBSTR();
	SetDlgItemText(IDC_BT_INTP, strVal);

	// speed unit
	if(strVal=="P") {
		strUnit = _T("%");
	}
	else {
		strUnit = _T("mm/s");
	}
	SetDlgItemText(IDC_ST_SPD_UNIT, strUnit);

	// speed
	p_state_->GetVarFlt('G', 8, &fVal);

	strVal.Format(_T("%.1f"), fVal);
	SetDlgItemText(IDC_ED_VAR_FLT, strVal);
}


// --------------------------------------------------------
/// @brief		Set step parameters.
///				V5$: interpolation ("P", "L", "C", ..)
///				V6$: speed unit ("%", "mm/s")
///				V8!: speed
// --------------------------------------------------------
void DlgState::OnBnClickedStepPrmSet()
{
	float	fVal;
	TCHAR	tcaVal[10];
	CString	strVal;


	// interpolation
	GetDlgItemText(IDC_BT_INTP, strVal);
	p_state_->SetVarStr('G', 5, _bstr_t(strVal));

	// speed unit
	GetDlgItemText(IDC_ST_SPD_UNIT, strVal);
	p_state_->SetVarStr('G', 6, _bstr_t(strVal));

	// speed
	GetDlgItemText(IDC_ED_VAR_FLT, tcaVal, 10);
	fVal = (float)_tstof(tcaVal);
	
	p_state_->SetVarFlt('G', 8, fVal);
}


// --------------------------------------------------------
/// @brief		open joystick jog test dialog-box
// --------------------------------------------------------
void DlgState::OnBnClickedJoyJog()
{
	DlgJoyJog	dlgJoyJog;

	dlgJoyJog.SetProxy(p_state_);

	dlgJoyJog.DoModal();
}


// --------------------------------------------------------
/// @brief		forcefully unsubscribe event-receiving
// --------------------------------------------------------
void DlgState::OnBnClickedEndEvtHandle()
{
	if(p_state_==NULL) return;

	int iHEvt = GetDlgItemInt(IDC_ED_H_EVT, 0, 0);
	p_state_->EndEvent(iHEvt);
}
