﻿#pragma once

#include "resource.h"


class HRRpcCliDlg;

// forward declarations
namespace hr_rpc_proxy
{
	interface IBase;
	interface IState;
	interface IPose;
};


// DlgState dialog-box

class DlgState : public CDialog
{
	DECLARE_DYNAMIC(DlgState)

public:
	DlgState(CWnd* pParent = NULL);   // standard constructor
	virtual ~DlgState();

// dialog-box data
	enum { IDD = IDD_STATUS };

	void set_module(HMODULE h_module) { h_module_ = h_module; }
	void set_base(hr_rpc_proxy::IBase* p_base) { p_base_ = p_base; }

public:
	// DDX ----------------------------
	
	// i/o
	CEdit		m_edIoObjIdx;
	CComboBox	m_cbIoClass;
	CComboBox	m_cbIoType;
	CEdit		m_edIoValNew;
	CButton		m_btIoSetVal;

	// variable
	CButton		m_btVarGlobal;
	CButton		m_btVarLocal;
	CComboBox	m_cbVarType;

	CComboBox	m_cbToolNo;		///< tool data
	CComboBox	m_cbUCrd;		///< robot current pose

	// target pose
	CButton m_btBase;
	CButton m_btAngle;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()

protected:
	int InitProxyState();
	int EndProxyState();

	CString OperTimeDispProc(int iDay, int iDt);
	CString MotOnTimeDispProc(int iDay, int iDt);
	
	void UpdateEvent();
	void UpdateCurPose();
	CString MakePoseStr(const hr_rpc_proxy::IPose* pPose);
	void UpdateIo();
	void UpdateVar();

private:
	HRRpcCliDlg*			dlgp_main_;
	HMODULE					h_module_;		///< HRRpcProxy DLL handle
	hr_rpc_proxy::IBase*	p_base_;		///< pointer to IBase interface
	hr_rpc_proxy::IState*	p_state_;		///< pointer to IState interface
	hr_rpc_proxy::IPose*	p_pose_;		///< pointer to IPose interface
	
public:
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();

	afx_msg void OnTimer(UINT_PTR nIDEvent);
	
	afx_msg void OnBnClickedPbStart();
	afx_msg void OnBnClickedPbStop();
	afx_msg void OnBnClickedPbReset();
	afx_msg void OnBnClickedSelJob();
	afx_msg void OnBnClickedSelStepFunc();

	afx_msg void OnCbnSelchangeCbToolNo();
	afx_msg void OnBnClickedSelToolNo();
	afx_msg void OnBnClickedSetTool();

	afx_msg void OnCbnSelchangeCbIoClass();
	afx_msg void OnBnClickedIoSetVal();
	afx_msg void OnBnClickedVarSetVal();
	
	afx_msg void OnBnClickedRBase();
	afx_msg void OnBnClickedRAngle();
	afx_msg void OnBnClickedPoseGet();
	afx_msg void OnBnClickedPoseSet();

	afx_msg void OnBnClickedBtIntp();
	afx_msg void OnBnClickedStepPrmGet();
	afx_msg void OnBnClickedStepPrmSet();

	afx_msg void OnBnClickedJoyJog();
	afx_msg void OnBnClickedEndEvtHandle();
};
