﻿
// HRRpcCliDlg.cpp : implementation file
//

#include "stdafx.h"
#include <TCHAR.H>
#include "DlgState.h"
#include "DlgMngFile.h"
#include "COM/Loose_COM.h"
#include "HRRpcCli.h"
#include "HResMsg.h"
#include "HRRpcCliDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define SVC_PROG_BASE				0x1000000
#define SVC_SET_PROG_NO				(SVC_PROG_BASE + 0x1000)	// 프로그램 번호 선택



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// HRRpcCliDlg dialog

// --------------------------------------------------------
/// @brief		constructor
// --------------------------------------------------------
HRRpcCliDlg::HRRpcCliDlg(CWnd* pParent /*=NULL*/)
	: CDialog(HRRpcCliDlg::IDD, pParent)
	, h_module_(NULL)
	, p_base_(NULL)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void HRRpcCliDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ED_IP_PC, m_editIpPc);
	DDX_Control(pDX, IDC_ED_IP_RC, m_editIpRc);
	DDX_Control(pDX, IDC_ED_LOG, m_editLog);
}


BEGIN_MESSAGE_MAP(HRRpcCliDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_MNG_FILE, &HRRpcCliDlg::OnBnClickedMngFile)
	ON_BN_CLICKED(IDC_LOCAL_HOST, &HRRpcCliDlg::OnBnClickedLocalHost)
	ON_BN_CLICKED(IDC_INIT, &HRRpcCliDlg::OnBnClickedInit)
	ON_BN_CLICKED(IDC_END, &HRRpcCliDlg::OnBnClickedEnd)
	ON_BN_CLICKED(IDC_STATE, &HRRpcCliDlg::OnBnClickedState)
END_MESSAGE_MAP()


// HRRpcCliDlg message handlers

// --------------------------------------------------------
/// @return		TRUE
/// @brief		initialize dialog
// --------------------------------------------------------
BOOL HRRpcCliDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// default IP addresses
	m_editIpPc.SetWindowText(_T("192.168.1.172"));
	m_editIpRc.SetWindowText(_T("192.168.1.72"));

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


// --------------------------------------------------------
/// @brief		handle destruction of dialog
// --------------------------------------------------------
void HRRpcCliDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// End proxy library, if not ended yet.
	if(p_base_)
	{
		HRESULT hr = p_base_->Close();
		EndProxyBase();
	}
}


void HRRpcCliDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void HRRpcCliDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR HRRpcCliDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


// --------------------------------------------------------
/// @return
///			- 0		success
///			- -1	already loaded
///			- -2	failed in LoadLibrary()
///			- -3	failed in getting interface
/// @brief		Initialize HRRpcProxy library - Base
// --------------------------------------------------------
int HRRpcCliDlg::InitProxyBase()
{
	CString		strMsg, strPathFName;
	HRESULT		hr;


	// already loaded
	if(h_module_) return -1;

	// ------------------------------------------
	// DLL dynamic linking
	const char* cpFNameDLL 
#ifdef _WIN64
		= "HRRpcProxy_x64.dll";
#else // 32-bit platform
		= "HRRpcProxy.dll";
#endif
	if((h_module_ = LoadLibraryA(cpFNameDLL)) == NULL)
	{
		strMsg = "Error in loading library\r\n";
		strMsg += cpFNameDLL;
		MessageBox(strMsg, 0, MB_OK | MB_ICONSTOP);
		return -2;
	}

	// ------------------------------------------
	// create COM component instance & get interface

	// IBase
	hr = CreateInstanceFromInst(h_module_, hr_rpc_proxy::CLSID_Base, hr_rpc_proxy::IID_IBase, (void**)&p_base_);
	if(FAILED(hr)) {
		strMsg.Format(_T("Error in getting IBase.\r\n%s"), hres2msg(hr));
		MessageBox(strMsg, 0, MB_OK | MB_ICONSTOP);
		return -3;
	}

	
	return 0;
}


// --------------------------------------------------------
/// @return
///			- 0		success
///			- -1	already unloaded
/// @brief		unload HRRpcProxy DLL library
// --------------------------------------------------------
int HRRpcCliDlg::EndProxyBase()
{
	// already unloaded
	if(h_module_==NULL) return -1;

	// release COM interfaces
	if(p_base_)
	{
		p_base_->Release();
		p_base_ = NULL;
	}

	FreeLibrary(h_module_);
	h_module_ = NULL;
	
	return 0;
}

// --------------------------------------------------------
/// @param		str		string to log
/// @brief		Append str to event log Edit
// --------------------------------------------------------
void HRRpcCliDlg::LogToMonitor(LPCTSTR str)
{
	CString strMoni;
	
	m_editLog.GetWindowText(strMoni);
	strMoni += str;

	m_editLog.SetSel(INT_MAX-1, INT_MAX-1, TRUE);
	m_editLog.ReplaceSel(str);
}


// --------------------------------------------------------
/// @brief		set IP address to localhost
// --------------------------------------------------------
void HRRpcCliDlg::OnBnClickedLocalHost()
{
	m_editIpPc.SetWindowText(_T("127.0.0.1"));
	m_editIpRc.SetWindowText(_T("127.0.0.1"));
}


// --------------------------------------------------------
/// @brief		initialize HR-RPC proxy and IBase interface
// --------------------------------------------------------
void HRRpcCliDlg::OnBnClickedInit()
{
	CString		strIpPc, strIpRc;
	HRESULT		hr;
	int			iret;


	// Initialize HRRpcProxy library - Base
	iret = InitProxyBase();
	if(iret<0) return;


	// read IP addresses from edit
	m_editIpPc.GetWindowText(strIpPc);	// PC (local)
	m_editIpRc.GetWindowText(strIpRc);	// Robot controller (remote)

	// Initialize
	int	iErrCode;
	p_base_->SetLicenseKeyCode(12606732, 20180531);
	hr = p_base_->Open(_bstr_t((LPCTSTR)strIpPc), _bstr_t((LPCTSTR)strIpRc), &iErrCode);
	if(FAILED(hr)) {				// failure
		EndProxyBase();
		return;
	}
}


// --------------------------------------------------------
/// @brief		end IBase interface and HR-RPC proxy
// --------------------------------------------------------
void HRRpcCliDlg::OnBnClickedEnd()
{
	// Close
	if(p_base_) {
		HRESULT hr = p_base_->Close();
	}

	EndProxyBase();
}


// --------------------------------------------------------
/// @brief		Open Test State dilaog
// --------------------------------------------------------
void HRRpcCliDlg::OnBnClickedState()
{
	DlgState	dlgState(this);

	if(p_base_==NULL) return;

	dlgState.set_module(h_module_);
	dlgState.set_base(p_base_);

	dlgState.DoModal();
}


// --------------------------------------------------------
/// @brief		Open Test MngFile dilaog
// --------------------------------------------------------
void HRRpcCliDlg::OnBnClickedMngFile()
{
	DlgMngFile	dlgMngFile(this);

	if(p_base_==NULL) return;

	dlgMngFile.set_module(h_module_);
	dlgMngFile.set_base(p_base_);

	dlgMngFile.DoModal();
}
