﻿///////////////////////////////////////////////////////////
/**
	@file	JoyJog.h
	@author Hyundai Heavy Industries Co., Ltd.
	@brief	definition for structure of JoyJog
*/

#pragma once


///////////////////////////////////////////////////////////
/**
	@union	JoyJog
	@author Choi, Won-Hyuk, Hyundai Heavy Industries Co., Ltd.
	@brief	Struct for JoystickJog bit-field.
			It is used as an argument type of IState::JoystickJog() function.
*/
struct JoyJogBits
{
	BYTE bJ1_N		:1;		///< J1- */
    BYTE bJ1_P		:1;		///< J1+ */
	BYTE bJ2_N		:1;		///< J2- */
    BYTE bJ2_P		:1;		///< J2+ */
	BYTE bJ3_N		:1;		///< J3- */
    BYTE bJ3_P		:1;		///< J3+ */
	BYTE bJ4_N		:1;		///< J4- */
    BYTE bJ4_P		:1;		///< J4+ */
	
	BYTE bJ5_N		:1;		///< J5- */
    BYTE bJ5_P		:1;		///< J5+ */
	BYTE bJ6_N		:1;		///< J6- */
    BYTE bJ6_P		:1;		///< J6+ */
	BYTE bJ7_N		:1;		///< J7- */
    BYTE bJ7_P		:1;		///< J7+ */
	BYTE bJ8_N		:1;		///< J8- */
    BYTE bJ8_P		:1;		///< J8+ */
	// (most-sig. bit)
};

union JoyJog
{
	JoyJogBits	bits;		/**< bit-field */
	USHORT		usBits;		/**< for JoystickJog() parameter */
};
