﻿#include "stdafx.h"

#include "PushButton.h"

/////////////////////////////////////////////////////////////////////////////
// CPushButton

// --------------------------------------------------------
/// @brief	Constructor
// --------------------------------------------------------
CPushButton::CPushButton()
{
	m_bPushed = FALSE;
}


// --------------------------------------------------------
/// @brief	Destructor
// --------------------------------------------------------
CPushButton::~CPushButton()
{
}


BEGIN_MESSAGE_MAP(CPushButton, CButton)
	//{{AFX_MSG_MAP(CPushButton)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPushButton message handlers


void CPushButton::DrawItem(LPDRAWITEMSTRUCT)
{
	//ASSERT(FALSE);
}


// --------------------------------------------------------
/// @brief	handler for push-down of button
// --------------------------------------------------------
void CPushButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	NMHDR	nmh;
	int iId = GetDlgCtrlID();
	
	nmh.code = BN_PUSHED;
	nmh.hwndFrom = m_hWnd;
	nmh.idFrom = iId;

	GetParent()->SendNotifyMessage(WM_NOTIFY, iId, LPARAM(&nmh));
	
	m_bPushed = TRUE;

	CButton::OnLButtonDown(nFlags, point);
}


// --------------------------------------------------------
/// @brief	handler for pop-up of button
// --------------------------------------------------------
void CPushButton::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	m_bPushed = FALSE;

	CButton::OnLButtonUp(nFlags, point);
}


// --------------------------------------------------------
/// @return
/// -			TRUE  : pushed
/// -			FALSE : not pushed
/// @brief	return if it is pushed or not
// --------------------------------------------------------
BOOL CPushButton::IsPushed() 
{ 
	return m_bPushed; 
}
