﻿// filename : MonAx.h
// 
/// @author Choi, Won-Hyuk, Hyundai Heavy Industries Co., Ltd.
/// @section CREATEINFO
///  Creator	: Hyundai Heavy Industries Co., Ltd.
/// @date 2016-05-24

#pragma once
#include "windows.h"
#include <comutil.h>	// _bstr_t


// forward declaration
namespace hr_rpc_proxy
{
	interface IBase;
};


/// @brief		Do Monitoring Hi5/Hi5a controller's joint & TCP values
class MonAx
{
public:
	MonAx(void);

	int Init(const char* cpIpLocal, const char* cpIpRemote);
	int End();

	int DoMonitoring();

protected:
	int InitSock();
	int EndSock();
	int InitProxyBase();
	int EndProxyBase();

private:
	_bstr_t					bstrIpLocal;
	_bstr_t					bstrIpRemote;
	HMODULE					h_module_;
	hr_rpc_proxy::IBase*	p_base_;
};
