﻿#pragma once


namespace hr_rpc_proxy {

///////////////////////////////////////////////////////////
/**
	@interface	IProgress
	@author		Choi, Won-Hyuk, Hyundai Heavy Industries Co., Ltd.
	@brief		Interface of Progress.
	@remarks	Define your Progress class by Inheriting IProgress.
				You can implement some U/I routine in IProgress::SetRatio function.
				Set the class's instance with IFileMan::SetProgress
				While ReadFile and WriteFile function,
				IFileMan will callback the IProgress::SetRatio function.
*/
interface IProgress
{
public:
	// --------------------------------------------------------
	/// @param[in]	lRatio		progress ratio(0 ~ 100%)
	/// @return		void
	/// @brief		set the progress ratio(%)
	// --------------------------------------------------------
	virtual void SetRatio(long lRatio) = 0;
};

} // namespace hr_rpc_proxy
